//duelflintlock.cs

//we'll only get this far if we actually have the gun add-on
//  so it's safe to directly use stuff from that
//AddDamageType(<name>, <suicide message>, <kill message>, <vehicle damage scale>, <is direct damage>);
AddDamageType("duelflintlock",   '<bitmap:add-ons/Weapon_flintlock/CI_dualflintlock> %1',    '%2 <bitmap:add-ons/Weapon_flintlock/CI_dualflintlock> %1',0.05,1);
datablock ProjectileData(duelflintlockProjectile)
{
   projectileShapeName = "add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 30;
   directDamageType    = $DamageType::duelflintlock;
   radiusDamageType    = $DamageType::duelflintlock;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse	  = 0;
   explosion           = gunExplosion;
   particleEmitter     = "";

   muzzleVelocity      = 90;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";


};

//////////
// item //
//////////
datablock ItemData(duelflintlockItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./flintlock.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Dual Flintlocks";
	iconName = "./dualflintlock";
	doColorShift = false;
	colorShiftColor = "0.400 0.196 0 1.000";

	 // Dynamic properties defined by the scripts
	image = duelflintlockImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(duelflintlockImage)
{
   // Basic Item properties
   shapeFile = "./flintlock3.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = duelflintlockProjectile;
   projectileType = Projectile;



   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;
   colorShiftColor = "0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "Ready";
	stateTimeoutValue[0] = 0.2;
	stateSequence[0] = "ready";

	stateName[1] = "Ready";
	stateSequence[1] = "ready";
	stateTransitionOnTriggerDown[1] = "pFire";
	
		stateName[2]                    = "pFire";
	stateTransitionOnTimeout[2]     = "Fire";
	stateTimeoutValue[2]            = 0.01;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateWaitForTimeout[2]			= true;
	//stateEmitter[2]					= musketsparkEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "ejectNode";

	stateName[3] = "Fire";
	stateEjectShell[3]       = true;
	stateSequence[3] = "Fire";
	stateTransitionOnTimeout[3] = "Smoke";
    stateWaitForTimeout[3] = true;
	stateTimeoutValue[3] = 0.09;
	stateFire[3] = true;
	stateAllowImageChange[3] = false;
	stateScript[3] = "onFire";
	stateSound[3]					= flintlockfireSound;
    stateEmitter[3]					= gunFlashEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";

   stateName[4] = "Smoke";
	stateEmitter[4]					= gunSmokeEmitter;
	stateEmitterTime[4]				= 0.05;
	stateEmitterNode[4]				= "muzzleNode";
		stateSequence[4]                = "reload";
	stateTimeoutValue[4]            = 0.3;
	   stateWaitForTimeout[4] = true;
	stateTransitionOnTimeout[4]     = "Reload";

	
	stateName[5] = "Reload";
	stateAllowImageChange[5] = false;
	stateTransitionOnTriggerUp[5] = "FireAkimbo";
	stateSequence[5] = "ready";

	stateName[6] = "FireAkimbo";
	stateTimeoutValue[6] = 0.09;
	stateScript[6] = "onFireAkimbo";
	stateTransitionOnTimeOut[6] = "ready";
};


function duelflintlockImage::onFireAkimbo(%this,%obj,%slot)
{
   %obj.setImageTrigger(1,1);
}


datablock ShapeBaseImageData(LeftHandedFlintlockImage)
{
   // Basic Item properties
   shapeFile = "./flintlock3.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 1;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = duelflintlockProjectile;
   projectileType = Projectile;



   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = false;

   doColorShift = false;
   colorShiftColor = "0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "Ready";
	stateTimeoutValue[0] = 0.2;
	stateSequence[0] = "ready";
   stateSound[0]		= weaponSwitchSound;

	stateName[1] = "Ready";
	stateSequence[1] = "ready";
	stateTransitionOnTriggerDown[1] = "pFire";
	
			stateName[2]                    = "pFire";
	stateTransitionOnTimeout[2]     = "Fire";
	stateTimeoutValue[2]            = 0.01;

	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";

	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= musketsparkEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "ejectNode";

	stateName[3] = "Fire";
	stateEjectShell[3]       = true;
	stateSequence[3] = "Fire";
	stateTransitionOnTimeout[3] = "Smoke";
   stateWaitForTimeout[3] = true;
	stateTimeoutValue[3] = 0.09;
	stateFire[3] = true;
	stateAllowImageChange[3] = false;
	stateScript[3] = "onFire";
	stateSound[3]					= flintlockfireSound;
   stateEmitter[3]					= gunFlashEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";

   stateName[4] = "Smoke";
	stateEmitter[4]					= gunSmokeEmitter;
	stateEmitterTime[4]				= 0.05;
		stateSequence[4]                = "reload";
	stateEmitterNode[4]				= "muzzleNode";
	stateTimeoutValue[4]            = 0.3;
	   stateWaitForTimeout[4] = true;
	stateTransitionOnTimeout[4]     = "Reload";


	
	stateName[5] = "Reload";
	stateAllowImageChange[5] = false;
	stateTransitionOnTriggerUp[5] = "Ready";
	stateSequence[5] = "ready";


};



function duelflintlockImage::onMount(%this, %obj, %slot)
{
   Parent::onMount(%this, %obj, %slot);
   //mount lefthanded gun
   %obj.mountImage(LeftHandedFlintlockImage, 1);
   //%obj.playThread(0, armreadyboth);
}
function duelflintlockImage::onUnMount(%this, %obj, %slot)
{
   Parent::onUnMount(%this, %obj, %slot);
   //unmount lefthanded gun
   %obj.unMountImage(1);
   //%obj.playThread(0, root);
}


function LeftHandedFlintlockImage::onMount(%this, %obj, %slot)
{
   Parent::onMount(%this, %obj, %slot);
   %obj.playThread(1, armreadyboth);
}
function LeftHandedFlintlockImage::onUnMount(%this, %obj, %slot)
{
   Parent::onUnMount(%this, %obj, %slot);
}


