
datablock AudioProfile(flintlockfireSound)
{
   filename    = "./flintlock.wav";
   description = AudioClosest3d;
   preload = true;
};


datablock ParticleData(musketSparks)
{
   dragCoefficient      = 1;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 300;
   lifetimeVarianceMS   = 0;
   textureName          = "./spark00";
   colors[0]     = "0.56 0.36 0.26 1.0";
   colors[1]     = "0.56 0.36 0.26 1.0";
   colors[2]     = "1.0 0.36 0.26 0.0";
   sizes[0]      = 0.6;
   sizes[1]      = 0.2;
   sizes[2]      = 0.05;
   times[0]      = 0.0;
   times[1]      = 0.2;
   times[2]      = 1.0;

};

datablock ParticleEmitterData(musketSparkEmitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   ejectionVelocity = 4;
   velocityVariance = 2.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 50;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 100;
   particles = "musketSparks";
};




//projectile
AddDamageType("flintlockDirect",   '<bitmap:add-ons/weapon_flintlock/ci_flintlock> %1',    '%2 <bitmap:add-ons/weapon_flintlock/ci_flintlock> %1',1,1);
AddDamageType("flintlockRadius",   '<bitmap:add-ons/weapon_flintlock/ci_flintlock> %1',    '%2 <bitmap:add-ons/weapon_flintlock/ci_flintlock> %1',1,0);
datablock ProjectileData(flintlockProjectile)
{
   projectileShapeName = "add-ons/weapon_gun/bullet.dts";
   directDamage        = 30;
   directDamageType  = $DamageType::flintlockDirect;
   radiusDamageType  = $DamageType::flintlockRadius;
   impactImpulse	   = 200;
   verticalImpulse	   = 200;
   explosion           = gunExplosion;
   //particleEmitter     = flintlockTrailEmitter;



   muzzleVelocity      = 120;
   velInheritFactor    = 0;


   armingDelay         = 0; 
   lifetime            = 25000;
   fadeDelay           = 3000;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";


};


//////////
// item //
//////////
datablock ItemData(flintlockItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./flintlock3.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Flintlock";
	iconName = "./flintlock";
	doColorShift = false;
	colorShiftColor = "0.400 0.196 0 1.000";

	 // Dynamic properties defined by the scripts
	image = flintlockImage;
	canDrop = true;
};

datablock ShapeBaseImageData(flintlockImage)
{
   // Basic Item properties
   shapeFile = "./flintlock3.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = flintlockItem;
   ammo = " ";
   projectile = flintlockProjectile;
   projectileType = Projectile;


   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   colorShiftColor = "0.400 0.196 0 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "pFire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";
	
		stateName[2]                    = "pFire";
	stateTransitionOnTimeout[2]     = "Fire";
	stateTimeoutValue[2]            = 0.01;

	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";

	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= gunSmokeEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "ejectNode";



	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Smoke";
	stateTimeoutValue[3]            = 0.01;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;

	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]			= true;
	stateEmitter[3]					= gunFlashEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateSound[3]					= flintlockfireSound;


	stateName[4] = "Smoke";
	stateEmitter[4]					= gunSmokeEmitter;
	stateEmitterTime[4]				= 0.5;
	stateEmitterNode[4]				= "muzzleNode";
	stateTimeoutValue[4]            = 0.01;
	stateTransitionOnTimeout[4]     = "Reload";

	stateName[5] = "reload";
	stateSequence[5]                = "reload";
	stateTimeoutValue[5]            = 0.5;
	stateTransitionOnTimeout[5]     = "ready";

};




function FlintlockImage::onFire(%this,%obj,%slot)
{


	%projectile = %this.projectile;
	%spread = 0.00085;
	%shellcount = 1;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}